<template>
	<f7-page name="accountbanksform" @page:beforein="onPageBeforeIn">
		<!-- Top Navbar -->
		<f7-navbar :sliding="false" large>
			<f7-nav-left back-link>
            </f7-nav-left>
            <f7-nav-title class="show-small-title">Rekening Bank</f7-nav-title>
            <f7-nav-title-large>{{ formType }} Rekening</f7-nav-title-large>
		</f7-navbar>

		<!-- Page content-->
		<f7-block style="text-align: justify;padding:20px;border-radius:7px;" class="no-margin gradient-cyan">
			<h3 class="no-margin">Penting!</h3>
            <p>Data Anda selalu rahasia dan tidak akan kami beritahukan kepada pihak ketiga.</p>
        </f7-block> 
        <f7-list no-hairlines>
			<f7-list-item title="Pilih Bank" smart-select :smart-select-params="{'closeOnSelect': true}">
				<select 
					ref="bank" 
					name="bank" 
					class="bank"
					:value="bankAccountForm.bank"
					@change="bankAccountForm.bank = $event.target.value">
					<option
						v-for="item in banks" 
						:value="item.id"
						v-bind:key="item.id">{{ item.name }}</option>
				</select>
			</f7-list-item>
			<f7-list-input
				ref="account_name"
				label="Nama"
				placeholder="Nama lengkap"
				maxlength="255"
				clear-button
				:value="bankAccountForm.account_name"
				@input="bankAccountForm.account_name = $event.target.value">
			</f7-list-input>
			<f7-list-input
				ref="account_number"
				label="No. Rekening"
				placeholder="No. Rekening"
				maxlength="255"
				type="number"
				clear-button
				:value="bankAccountForm.account_number"
				@input="bankAccountForm.account_number = $event.target.value">
			</f7-list-input>
			<f7-list-input
				ref="branch"
				label="Kantor Cabang"
				placeholder="Nama unit/kantor cabang"
				maxlength="255"
				clear-button
				:value="bankAccountForm.branch"
				@input="bankAccountForm.branch = $event.target.value">
			</f7-list-input>
			<f7-list-input
				ref="description"
				type="textarea"
				label="Catatan"
				placeholder="Ketik catatan"
				maxlength="255"
				resizable					
				:value="bankAccountForm.description"
				@input="bankAccountForm.description = $event.target.value">
			</f7-list-input>
		</f7-list>
		<f7-button @click="doSubmit" fill-ios round-ios color="white" icon-f7="arrow_right" class="gradient-button-blue text-align-left" large>{{ formType }}</f7-button>
    </f7-page>
</template>
<script>
import { mapGetters } from 'vuex';
import { setTimeout } from 'timers';
import { dateFormat, capitalize, parseError } from '../js/utils';
export default {
    name: 'BankAccountForm',
    data(){
        return{
            formType: 'Tambah',
            bankAccountForm: {
                id: null,
                account_name: '',
                account_number: '',
                branch: '',
                description: '',
                bank: null
            }
        };
    },
    computed: {
        ...mapGetters('auth', ['user', 'bankaccount']),
        ...mapGetters('bank', ['banks'])
    },
    methods: {
        getBanks(){
            const self = this;

            self.$store.dispatch('bank/getBanks', {
                perpage: 100
            });
        },
        onPageBeforeIn(page){
			const self = this;
			const app = self.$f7;
			const $$ = self.$$;
            const $el = $$(self.$el);

            self.getBanks();

			if(page.detail.from == 'next' && self.$f7route.params && self.$f7route.params.id){
				self.formType = 'Ubah';
				self.bankAccountForm.id = parseInt(self.$f7route.params.id);
			
				app.preloader.show('green');

				self.$store.dispatch('auth/viewBankAccount', {
                    id: self.bankAccountForm.id,
                    only: 'account_name,account_number,branch,description,bank.id,bank.name,holder.id,holder.profile.fullname'
				}).then((response) => {
					
                    self.bankAccountForm.account_name = self.bankaccount.account_name;
                    self.bankAccountForm.account_number = self.bankaccount.account_number;
                    self.bankAccountForm.branch = self.bankaccount.branch != null ? self.bankaccount.branch : '';
                    self.bankAccountForm.description = self.bankaccount.description != null ? self.bankaccount.description : '';
                    self.bankAccountForm.bank = self.bankaccount.bank.id; 
                    
                    setTimeout(()=>{
                        $el.find('select.bank').find('option[value="'+self.bankaccount.bank.id+'"]').prop('selected', true).trigger('change');
                    },100);

					app.preloader.hide();
				});
            }     
            
		},
		onPageBeforeOut(page){
			const self = this;

			if(page.detail.name == 'bankaccountform'){
				self.bankAccountForm = {
					id: null,
                    accountName: '',
                    accountNumber: '',
                    branch: '',
                    description: '',
                    bank: null
				}
			}
        },
        doSubmit(){
            const self = this;
			const app = self.$f7;

            if(self.bankAccountForm.bank == null){
                app.dialog.alert('Silahkan pilih bank.', 'RingSatu');
                return false;
			}else if(self.bankAccountForm.account_name.trim().length == 0){
				app.dialog.alert('Nama akun wajib diisi', 'RingSatu');
				return false;
			}else if(/^([a-zA-Z0-9\s]{1,255})$/.test(self.bankAccountForm.title) == false){
				app.dialog.alert('Nama akun hanya boleh diisi dengan dengan huruf, angka dan spasi.', 'RingSatu');
				return false;
			}else if(self.bankAccountForm.account_number.trim().length == 0){
				app.dialog.alert('No. rekening wajib diisi', 'RingSatu');
                return false;
            }else if(/^([0-9]+)$/.test(self.bankAccountForm.account_number) == false){
				app.dialog.alert('Masukkan angka pada no. rekening', 'RingSatu');
				return false;
			}else if(self.bankAccountForm.branch.trim().length > 255){
				app.dialog.alert('Panjang Unit/Kantor cabang maksimal 255 karakter', 'RingSatu');
				return false;			
			
			}else if(self.bankAccountForm.description.trim().length > 255){
				app.dialog.alert('Panjang catatan maksimal 255 karakter', 'RingSatu');
				return false;
			}

			app.preloader.show('green');

			let action = '';
			let params = {};

			if(self.formType == 'Ubah'){
				params.id = parseInt(self.$f7route.params.id);
				action = 'auth/editBankAccount';
			}else{
				action = 'auth/createBankAccount';
			}

			params.account_name = self.bankAccountForm.account_name;
			params.account_number = self.bankAccountForm.account_number;
			params.branch = self.bankAccountForm.branch;
			params.description = self.bankAccountForm.description;
            params.bank = parseInt(self.bankAccountForm.bank);
            params.exclude = 'role.permissions,parents.childs,parents.role.permissions';

			self.$store.dispatch(action, params).then((response) => {
				app.preloader.hide();

				if('errors' in response){
					let error = parseError(response.errors);
					app.dialog.alert(error.messages, 'RingSatu');
					return false;
				}else{
					self.$f7router.back({
						ignoreCache: true
					});
				}
			});
        }
    }
}
</script>
